(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('m-dynamic-dialog', ['exports', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory(global['m-dynamic-dialog'] = {}, global.ng.core, global.rxjs, global.ng.common));
}(this, (function (exports, core, rxjs, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var MDynamicDialogData = /** @class */ (function () {
        function MDynamicDialogData() {
        }
        MDynamicDialogData = __decorate([
            core.Injectable()
        ], MDynamicDialogData);
        return MDynamicDialogData;
    }());

    var MDynamicDialogReference = /** @class */ (function () {
        function MDynamicDialogReference() {
            this.onSave = new rxjs.Subject();
            this.onClose = new rxjs.Subject();
            this.saveButtonEnabled = true;
            this.closeButtonEnabled = true;
            this.getForm = new rxjs.Subject();
            var date = new Date();
            this.dialogId = "dialog-" + date.getHours() + date.getMinutes() + date.getSeconds() + date.getMilliseconds();
            this.listenForCloseDialog();
        }
        MDynamicDialogReference.prototype.useForm = function (form) {
            this.getForm.next(form);
        };
        MDynamicDialogReference.prototype.save = function (data) {
            this.onSave.next(data);
        };
        MDynamicDialogReference.prototype.close = function (data) {
            this.onClose.next(data);
        };
        MDynamicDialogReference.prototype.listenForCloseDialog = function () {
            var _this = this;
            this.onClose.subscribe(function (res) {
                var dialog = document.getElementById(_this.dialogId);
                var container = document.getElementById("m-dynamic-dialog-container");
                container.removeChild(dialog);
                var childrenCount = container.childElementCount;
                if (childrenCount == 0) {
                    document.body.removeChild(container);
                }
            });
        };
        MDynamicDialogReference = __decorate([
            core.Injectable()
        ], MDynamicDialogReference);
        return MDynamicDialogReference;
    }());

    var MDynamicDialogBodyComponent = /** @class */ (function () {
        function MDynamicDialogBodyComponent(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        MDynamicDialogBodyComponent.prototype.ngOnInit = function () {
        };
        MDynamicDialogBodyComponent.ctorParameters = function () { return [
            { type: core.ViewContainerRef }
        ]; };
        MDynamicDialogBodyComponent = __decorate([
            core.Component({
                selector: 'm-dynamic-dialog-body',
                template: "",
                styles: [""]
            })
        ], MDynamicDialogBodyComponent);
        return MDynamicDialogBodyComponent;
    }());

    var MDynamicDialogComponent = /** @class */ (function () {
        function MDynamicDialogComponent(ref) {
            this.ref = ref;
            this.id = "";
            this.headerHeight = "7vh";
            this.footerHeight = "5vh";
            this.bodyHeight = "";
            this.loaded = false;
            this.componentFactoryResolver = null;
            this.animationType = 0;
            this.animationTypes = exports.AnimationTypes;
            this.form = null;
        }
        MDynamicDialogComponent.prototype.handleKeyboardEvent = function (event) {
            if (this.parameter.Properties.closeOnEsc !== false) {
                this.close();
            }
        };
        MDynamicDialogComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.calculateDialogPropertiesAndSet(this.parameter.Properties);
            this.ref.getForm.subscribe(function (res) {
                console.log(res);
                _this.form = res;
            });
        };
        MDynamicDialogComponent.prototype.log = function (ss) {
            console.log("log from dialog container", ss);
        };
        MDynamicDialogComponent.prototype.ngAfterViewInit = function () {
            this.createComponent(this.componentFactoryResolver);
        };
        MDynamicDialogComponent.prototype.setComponentBuilders = function (cfr) {
            this.componentFactoryResolver = cfr;
        };
        MDynamicDialogComponent.prototype.calculateDialogPropertiesAndSet = function (properties) {
            if (properties.headerHeight) {
                this.headerHeight = properties.headerHeight;
            }
            if (properties.footerHeight) {
                this.footerHeight = properties.footerHeight;
            }
            if (properties.showHeader === true)
                this.headerHeight = "0";
            if (properties.showFooter === true)
                this.footerHeight = "0";
            this.bodyHeight = properties.height;
            this.loaded = true;
            return this;
        };
        MDynamicDialogComponent.prototype.createComponent = function (cfr) {
            var injector = core.Injector.create({
                providers: [
                    {
                        provide: MDynamicDialogReference,
                        useValue: this.ref
                    },
                    {
                        provide: MDynamicDialogData,
                        useValue: this.dialogData
                    }
                ]
            });
            var dynamicComponent = cfr.resolveComponentFactory(this.parameter.Component);
            if (dynamicComponent.selector == 'm-confirmation-dialog') {
                this.animationType = exports.AnimationTypes.Confirmation;
            }
            else {
                this.animationType = exports.AnimationTypes.Dynamic;
            }
            this.content.viewContainerRef.createComponent(dynamicComponent, 0, injector);
        };
        MDynamicDialogComponent.prototype.saveButtonEnabled = function () {
            return this.ref.saveButtonEnabled;
        };
        MDynamicDialogComponent.prototype.save = function () {
            this.ref.save();
        };
        MDynamicDialogComponent.prototype.close = function () {
            this.ref.close();
        };
        MDynamicDialogComponent.prototype.outsideClickClose = function () {
            this.ref.close();
        };
        MDynamicDialogComponent.ctorParameters = function () { return [
            { type: MDynamicDialogReference }
        ]; };
        __decorate([
            core.ViewChild(MDynamicDialogBodyComponent)
        ], MDynamicDialogComponent.prototype, "content", void 0);
        __decorate([
            core.HostListener('document:keydown.escape', ['$event'])
        ], MDynamicDialogComponent.prototype, "handleKeyboardEvent", null);
        MDynamicDialogComponent = __decorate([
            core.Component({
                selector: 'm-dynamic',
                template: "<!-- \r\n\r\n            [ngClass]=\"{\r\n            'm-dynamic-dialog': animationType === animationTypes.Dynamic, \r\n            'm-confirmation-dialog': animationType === animationTypes.Confirmation ,\r\n            'm-dynamic-dialog-hide': animationType === 0,\r\n            'm-confirmation-dialog-hide': animationType === 0\r\n        }\" hideConfirmation m-dynamic-dialog-hide\r\n -->\r\n\r\n<div class=\"m-dialog-environment\" [ngClass]=\"{'m-modal-background': parameter.Properties?.asModal !== false}\">\r\n    <div *ngIf=\"loaded\" class=\"m-dialog-container m-card m-no-padding\"\r\n\r\n        [ngStyle]=\"{'min-width': parameter.Properties?.width, 'max-width': parameter.Properties?.width}\">\r\n        <div *ngIf=\"parameter.Properties?.showHeader !== false\" class=\"m-header m-min-padding\" [ngStyle]=\"{\r\n                'height': headerHeight , \r\n                'width': parameter.Properties?.width\r\n            }\">\r\n            <div class=\"m-title\">\r\n                {{ parameter.Properties?.title }}\r\n            </div>\r\n            <span (click)=\"close()\">\r\n                <!-- <i class=\"fas fa-times m-pointer m-header-close\"></i> -->\r\n                <span class=\"close rounded heavy m-pointer m-header-close\"></span>\r\n            </span>\r\n        </div>\r\n\r\n        <div class=\"m-body\" [ngStyle]=\"{\r\n                'height': bodyHeight ? bodyHeight : '100%', \r\n                'width': parameter.Properties?.width ? parameter.Properties?.width : '100%'\r\n            }\">\r\n            <m-dynamic-dialog-body #content></m-dynamic-dialog-body>\r\n        </div>\r\n\r\n        <div *ngIf=\"parameter.Properties?.showFooter !== false\" class=\"m-footer m-min-padding\" [ngStyle]=\"{\r\n                'height': footerHeight, \r\n                'width': parameter.Properties?.width\r\n            }\">\r\n            <div class=\"m-min-padding\" *ngIf=\"parameter.Properties?.showCloseButton !== false\">\r\n                <button mButton (click)=\"close()\">\r\n                    {{ parameter.Properties?.closeButtonLabel ? parameter.Properties?.closeButtonLabel : 'Cancel' }}\r\n                </button>\r\n            </div>\r\n            <div class=\"m-min-padding\" *ngIf=\"parameter.Properties?.showSaveButton !== false\">\r\n                <button mButton [disabled]=\"form === null ? false : !form.valid\" (click)=\"save()\">\r\n                    {{ parameter.Properties?.closeButtonLabel ? parameter.Properties?.saveButtonLabel : 'Save' }}\r\n                </button>\r\n            </div>\r\n\r\n        </div>\r\n\r\n    </div>\r\n</div>",
                styles: ["button{outline:0}.m-dialog-wrapper{height:100%;width:100%}.m-modal-background{background:rgba(0,0,0,.5)}.m-card{background:#fff!important;border-radius:2px!important;display:inline-block!important;box-shadow:0 19px 38px rgba(0,0,0,.3),0 15px 12px rgba(0,0,0,.22)!important}.m-min-padding{padding:1vh!important}.m-pointer{cursor:pointer}.m-no-padding{padding:0}::-webkit-scrollbar{width:.8em;border-radius:.5em}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888}::-webkit-scrollbar-thumb:hover{background:#555}.m-dialog-container{position:absolute;border:0!important;box-shadow:0 12px 15px 0 rgba(0,0,0,.25)}.m-dynamic-dialog-show{opacity:0;-webkit-animation-name:showDynamic;animation-name:showDynamic;-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards}.m-confirmation-dialog-show{opacity:0;-webkit-animation-name:showConfirmation;animation-name:showConfirmation;-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards}.m-dynamic-dialog-hide{opacity:1;bottom:29%;-webkit-animation-name:hideDynamic;animation-name:hideDynamic;-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards}.m-confirmation-dialog-hide{opacity:0;-webkit-animation-name:hideConfirmation;animation-name:hideConfirmation;-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards}@-webkit-keyframes showDynamic{30%{bottom:0;opacity:0}100%{bottom:29%;opacity:1}}@keyframes showDynamic{30%{bottom:0;opacity:0}100%{bottom:29%;opacity:1}}@-webkit-keyframes hideDynamic{0%{bottom:29%;opacity:1}100%{bottom:0;opacity:0}}@keyframes hideDynamic{0%{bottom:29%;opacity:1}100%{bottom:0;opacity:0}}@-webkit-keyframes showConfirmation{0%{opacity:0}100%{opacity:1}}@keyframes showConfirmation{0%{opacity:0}100%{opacity:1}}@-webkit-keyframes hideConfirmation{0%{opacity:1}100%{opacity:0}}@keyframes hideConfirmation{0%{opacity:1}100%{opacity:0}}.m-dialog-environment{height:100%!important;width:100%!important;z-index:1000000000!important;position:absolute!important;display:flex!important;justify-content:center!important;align-items:center!important;overflow:hidden!important;top:0!important;left:0!important;right:0!important;bottom:0!important}.m-header{display:flex;justify-content:space-between;align-items:center;box-sizing:border-box!important;box-shadow:0 0 .5em rgba(0,0,0,.16)}.m-title{font-size:1.5em}.m-header-close{font-size:1.1em}.m-body{padding:1vh;overflow-y:auto;box-sizing:border-box!important}.m-footer{display:flex;justify-content:flex-end;align-items:center;box-shadow:0 0 1em rgba(0,0,0,.16);box-sizing:border-box!important}"]
            })
        ], MDynamicDialogComponent);
        return MDynamicDialogComponent;
    }());

    (function (AnimationTypes) {
        AnimationTypes[AnimationTypes["Dynamic"] = 1] = "Dynamic";
        AnimationTypes[AnimationTypes["Confirmation"] = 2] = "Confirmation";
    })(exports.AnimationTypes || (exports.AnimationTypes = {}));

    var MDynamicDialogParameter = /** @class */ (function () {
        function MDynamicDialogParameter() {
        }
        return MDynamicDialogParameter;
    }());

    var MConfirmationDialogComponent = /** @class */ (function () {
        function MConfirmationDialogComponent(dialogData, ref) {
            this.dialogData = dialogData;
            this.ref = ref;
            this.properties = null;
            this.properties = dialogData.data.properties;
        }
        MConfirmationDialogComponent.prototype.ngOnInit = function () {
        };
        MConfirmationDialogComponent.prototype.close = function () {
            this.ref.close();
        };
        MConfirmationDialogComponent.prototype.yesClick = function () {
            this.ref.close(true);
        };
        MConfirmationDialogComponent.prototype.noClick = function () {
            this.ref.close(false);
        };
        MConfirmationDialogComponent.ctorParameters = function () { return [
            { type: MDynamicDialogData },
            { type: MDynamicDialogReference }
        ]; };
        MConfirmationDialogComponent = __decorate([
            core.Component({
                selector: 'm-confirmation-dialog',
                template: "<div class=\"confirmation-container\">\n        <!-- <div class=\"title\">\n            {{properties?.title}}\n        </div> -->\n        <div class=\"message\" [innerHTML]=\"properties?.message\">\n        </div>\n    <div class=\"buttons\">\n        <button mButton (click)=\"yesClick()\">{{ properties?.yesButtonLabel ? properties?.yesButtonLabel : 'Yes' }}</button>\n        <button mButton (click)=\"noClick()\">{{ properties?.noButtonLabel ? properties?.noButtonLabel : 'No' }}</button>\n    </div>\n</div>",
                styles: ["button{outline:0}.m-dialog-wrapper{height:100%;width:100%}.m-modal-background{background:rgba(0,0,0,.5)}.m-card{background:#fff!important;border-radius:2px!important;display:inline-block!important;box-shadow:0 19px 38px rgba(0,0,0,.3),0 15px 12px rgba(0,0,0,.22)!important}.m-min-padding{padding:1vh!important}.m-pointer{cursor:pointer}.m-no-padding{padding:0}::-webkit-scrollbar{width:.8em;border-radius:.5em}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888}::-webkit-scrollbar-thumb:hover{background:#555}.confirmation-container{height:100%;width:100%}.message{display:flex;justify-content:center;align-items:center;font-size:1.3em;height:70%;width:100%;overflow-y:auto;font-weight:300}.buttons{height:30%;width:100%;display:flex;flex-direction:row;justify-content:space-around;align-items:center;font-size:1.2em;font-weight:400}"]
            })
        ], MConfirmationDialogComponent);
        return MConfirmationDialogComponent;
    }());

    var MDynamicDialogService = /** @class */ (function () {
        function MDynamicDialogService(componentFactoryResolver, applicationRef) {
            this.componentFactoryResolver = componentFactoryResolver;
            this.applicationRef = applicationRef;
        }
        MDynamicDialogService.prototype.createAndGetDialogReferenceInstance = function (parameter) {
            var reference = new MDynamicDialogReference();
            this.generateBaseDialog(reference, parameter);
            return reference;
        };
        MDynamicDialogService.prototype.checkIfDialogContExist = function () {
            var container = document.getElementById("m-dynamic-dialog-container");
            return container != null;
        };
        MDynamicDialogService.prototype.generateBaseDialog = function (reference, parameter) {
            if (!this.checkIfDialogContExist()) {
                this.generateDialogContainer();
            }
            var injectorCustom = core.Injector.create([
                {
                    provide: MDynamicDialogReference,
                    useValue: reference
                },
            ]);
            var dialogFactory = this.componentFactoryResolver.resolveComponentFactory(MDynamicDialogComponent).create(injectorCustom);
            dialogFactory.instance.setComponentBuilders(this.componentFactoryResolver);
            dialogFactory.instance.parameter = parameter;
            // dialogFactory.instance.form = parameter.Properties.
            dialogFactory.instance.dialogData = this.generateDialogData(parameter.Properties.data);
            this.applicationRef.attachView(dialogFactory.hostView);
            var dialog = dialogFactory.hostView.rootNodes[0];
            dialog.id = reference.dialogId;
            var dialogContainer = document.getElementById("m-dynamic-dialog-container");
            dialogContainer.append(dialog);
            this.applicationRef.tick();
        };
        MDynamicDialogService.prototype.generateDialogContainer = function () {
            var dialogContainer = document.createElement("div");
            dialogContainer.id = "m-dynamic-dialog-container";
            // dialogContainer.style.height = "100%";
            // dialogContainer.style.width = "100%";
            dialogContainer.style.position = "absolute !important";
            dialogContainer.style.background = "background: rgba(0, 0, 0, 0.5); !important";
            document.body.insertBefore(dialogContainer, document.body.firstChild);
        };
        MDynamicDialogService.prototype.generateDialogData = function (data) {
            var dialogData = new MDynamicDialogData();
            dialogData.data = data;
            return dialogData;
        };
        MDynamicDialogService.prototype.open = function (component, properties) {
            var parameter = new MDynamicDialogParameter();
            parameter.Component = component;
            parameter.Properties = properties;
            return this.createAndGetDialogReferenceInstance(parameter);
        };
        MDynamicDialogService.prototype.openConfirmation = function (properties) {
            return this.open(MConfirmationDialogComponent, {
                title: properties.title,
                height: properties.height ? properties.height : '20vh',
                width: properties.width ? properties.width : '20vw',
                data: {
                    properties: properties
                },
                showFooter: false
            });
        };
        MDynamicDialogService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef }
        ]; };
        MDynamicDialogService.ɵprov = core.ɵɵdefineInjectable({ factory: function MDynamicDialogService_Factory() { return new MDynamicDialogService(core.ɵɵinject(core.ComponentFactoryResolver), core.ɵɵinject(core.ApplicationRef)); }, token: MDynamicDialogService, providedIn: "root" });
        MDynamicDialogService = __decorate([
            core.Injectable({
                providedIn: "root"
            })
        ], MDynamicDialogService);
        return MDynamicDialogService;
    }());

    var MButtonDirective = /** @class */ (function () {
        /*
        
            height: 2vh;
            width: 3vw;
            display: flex;
            justify-content: space-between;
            align-items: center;
        */
        function MButtonDirective(el) {
            el.nativeElement.style.height = '2vh';
            el.nativeElement.style.width = '3vw';
            el.nativeElement.style.background = 'transparent';
            el.nativeElement.style.border = '0';
            el.nativeElement.className = "m-pointer";
            el.nativeElement.style.fontSize = "1.1em";
        }
        MButtonDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        MButtonDirective = __decorate([
            core.Directive({
                selector: '[mButton]'
            })
        ], MButtonDirective);
        return MButtonDirective;
    }());

    var MDynamicDialogModule = /** @class */ (function () {
        function MDynamicDialogModule() {
        }
        MDynamicDialogModule_1 = MDynamicDialogModule;
        MDynamicDialogModule.forRoot = function () {
            return {
                ngModule: MDynamicDialogModule_1,
                providers: [MDynamicDialogService, MDynamicDialogReference, MDynamicDialogData, MDynamicDialogParameter]
            };
        };
        var MDynamicDialogModule_1;
        MDynamicDialogModule = MDynamicDialogModule_1 = __decorate([
            core.NgModule({
                declarations: [
                    MDynamicDialogBodyComponent,
                    MDynamicDialogComponent,
                    MConfirmationDialogComponent,
                    MButtonDirective
                ],
                imports: [
                    common.CommonModule
                ],
                entryComponents: [
                    MDynamicDialogBodyComponent,
                    MDynamicDialogComponent,
                    MConfirmationDialogComponent
                ],
                exports: [
                    MDynamicDialogBodyComponent
                ]
            })
        ], MDynamicDialogModule);
        return MDynamicDialogModule;
    }());

    var MDynamicDialogProperties = /** @class */ (function () {
        function MDynamicDialogProperties() {
        }
        return MDynamicDialogProperties;
    }());

    exports.MConfirmationDialogComponent = MConfirmationDialogComponent;
    exports.MDynamicDialogBodyComponent = MDynamicDialogBodyComponent;
    exports.MDynamicDialogComponent = MDynamicDialogComponent;
    exports.MDynamicDialogData = MDynamicDialogData;
    exports.MDynamicDialogModule = MDynamicDialogModule;
    exports.MDynamicDialogParameter = MDynamicDialogParameter;
    exports.MDynamicDialogProperties = MDynamicDialogProperties;
    exports.MDynamicDialogReference = MDynamicDialogReference;
    exports.MDynamicDialogService = MDynamicDialogService;
    exports.ɵa = MButtonDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=m-dynamic-dialog.umd.js.map
