import { MDynamicDialogProperties } from '../models/m-dynamic-dialog-properties';
import { ComponentFactoryResolver, ApplicationRef, Type } from '@angular/core';
import { MDynamicDialogParameter } from '../models/m-dynamic-dialog-parameter';
import { MDynamicDialogReference } from './m-dynamic-dialog-reference.service';
import { MDynamicDialogData } from './m-dynamic-dialog-data.service';
import { MConfirmationDialogParameter } from '../models/m-confiramtion-dialog-parameter';
export declare class MDynamicDialogService {
    private componentFactoryResolver;
    private applicationRef;
    constructor(componentFactoryResolver: ComponentFactoryResolver, applicationRef: ApplicationRef);
    createAndGetDialogReferenceInstance(parameter: MDynamicDialogParameter): MDynamicDialogReference;
    checkIfDialogContExist(): boolean;
    generateBaseDialog(reference: MDynamicDialogReference, parameter: MDynamicDialogParameter): void;
    generateDialogContainer(): void;
    generateDialogData(data: any): MDynamicDialogData;
    open(component: Type<any>, properties: MDynamicDialogProperties): MDynamicDialogReference;
    openConfirmation(properties: MConfirmationDialogParameter): MDynamicDialogReference;
}
